/* ./src/crypt/arithmetic/mc68sun/sub.c */

static char *rcsid = "$Id: sub.c,v 1.3 1994/11/02 10:44:39 surkau Exp $";

/* 
 *
 * $Id: sub.c,v 1.3 1994/11/02 10:44:39 surkau Exp $
 *
 * $Log: sub.c,v $
 *
 */
 
/********************************************************************
 * Copyright (C) 1991, GMD. All rights reserved.                    *
 *                                                                  *
 *                                                                  *
 *                         NOTICE                                   *
 *                                                                  *
 *    Acquisition, use, and distribution of this module             *
 *    and related materials are subject to restrictions             *
 *    mentioned in each volume of the documentation.                *
 *                                                                  *
 ********************************************************************/

/*
 *	L_NUMBER subtraction

 *
 */
 
#include	"arithmetic.h"

/*	A - B	*/
/***************************************************************
 *
 * Procedure _sub
 *
 ***************************************************************/
#ifdef __STDC__

void _sub(
	register L_NUMBER	 *Ap,
	register L_NUMBER	 *Bp,
	register L_NUMBER	 *Diff
)

#else

void _sub(
	Ap,
	Bp,
	Diff
)
register L_NUMBER	 *Ap;
register L_NUMBER	 *Bp;
register L_NUMBER	 *Diff;

#endif

{
	register L_NUMBER	*opA = Ap, *Dp = Diff;
	register int	cnt, carry = 1;
	int	residual;

	if (lngofln(Ap)<lngofln(Bp)) ALU_exception(carry);
	
	cnt = lngofln(Bp); residual = lngofln(Ap) - lngofln(Bp);
	
	for ( ; cnt > 0; cnt--)
		carry = cadd( *++Ap, ~(*++Bp), ++Diff, carry );
		
	for(  ; !carry && (residual>0); residual-- )
		carry = cadd( *++Ap, ~(0), ++Diff, 0 );

	if(Diff != Ap)  for(  ; residual>0 ; residual-- )  *++Diff = *++Ap;

	if (carry) /* OK */;
	else	ALU_exception(carry);
	
	cnt = lngofln(opA);
	Diff = Dp + cnt;
	for (; (Diff>Dp) && !*Diff; Diff--) cnt--;

	lngofln(Dp) = cnt;
	
	return;
}
