/********************************************************************
 * Copyright (C) 1990-1994, GMD Darmstadt. All rights reserved.     *
 *                                                                  *
 *                                                                  *
 *                         NOTICE                                   *
 *                                                                  *
 *    Acquisition, use, and distribution of this module             *
 *    and related materials are subject to restrictions             *
 *    mentioned in each volume of the documentation.                *
 *                                                                  *
 ********************************************************************/


#include "asm_ctl.h"

#define parm_a %i0
#define parm_b %i1
#define parm_c %i2
#define save_c %g1
#define len_a %l0
#define len_c %l1
#define lw %l2
#define rw %l3
#define nw %l4
#define left %l5
#define right %l6
#define tmp1 %g2
#define tmp2 %g3
#define tmp3 %g4










/*      _shift()

	sparc-assembler

	Thomas Surkau 24.5.91
				*/







	ENTRY(_shift)
	PROLOGUE(752)

	ld [parm_a],len_a
	mov parm_c,save_c


/* not much to do if length equal 0 */
	tst len_a
	bne   L$I_zero
	nop 
	st len_a,[parm_c]
	b L$B_end
	nop
	L$I_zero :
	L$B_zero :


/* copy a to stack, if a and c have the same position in memory  */
	cmp parm_a,parm_c
	bne   L$I_samemem
	nop 
	sub %fp,752,tmp1
	st len_a,[tmp1]
	L$C_copy :
	inc 4,tmp1
	inc 4,parm_a
	ld [parm_a],tmp2
	st tmp2,[tmp1]
	deccc len_a
	bne  L$C_copy
	nop
	L$B_copy :
	sub %fp,752,parm_a
	ld [parm_a],len_a
	L$I_samemem :
	L$B_samemem :





/* different procedures for left and right shft
   and for special event b and 31==0 (word shft) */

	tst parm_b
	bl   L$I_sign
	nop 

	andcc parm_b,31,%g0
	bne   L$I_mod32
	nop 


/* shft words left (or only copy if b=0) */

	srl parm_b,5,parm_b
	add len_a,parm_b ,len_c
	st len_c,[parm_c]
	tst parm_b
	be L$B_fillzero
	nop
	L$C_fillzero :
	inc 4,parm_c
	st %g0,[parm_c]
	deccc parm_b
	bne  L$C_fillzero
	nop
	L$B_fillzero :

	tst len_a
	be L$B_cp1
	nop
	L$C_cp1 :
	inc 4,parm_c
	inc 4,parm_a
	ld [parm_a],tmp1
	st tmp1,[parm_c]
	deccc len_a
	bne  L$C_cp1
	nop
	L$B_cp1 :







	
	ba L$B_mod32
	nop ;
	L$I_mod32 :


/* shft bits left */

	and parm_b,31,left
	set 32,right
	sub right,left,right

	srl parm_b,5,parm_b
	add len_a,parm_b ,len_c
	st len_c,[parm_c]

	tst parm_b
	be L$B_fillzero2
	nop
	L$C_fillzero2 :
	inc 4,parm_c
	st %g0,[parm_c]
	deccc parm_b
	bne  L$C_fillzero2
	nop
	L$B_fillzero2 :

	clr rw
	tst len_a
	be L$B_shl
	nop
	L$C_shl :
	inc 4,parm_a
	inc 4,parm_c
	ld [parm_a],lw
	sll lw,left,nw
	srl rw,right,rw
	or nw,rw,nw
	st nw,[parm_c]
	mov lw,rw
	deccc len_a
	bne  L$C_shl
	nop
	L$B_shl :

/* inc length if the highest bit is shfted into the next word */

	srl rw,right,nw
	tst nw
	be   L$I_more
	nop 
	inc 4,parm_c
	st nw,[parm_c]
	inc len_c
	st len_c,[save_c]
	L$I_more :
	L$B_more :






	L$B_mod32 :
	
	ba L$B_sign
	nop ;
	L$I_sign :

	sub %g0,parm_b,parm_b
	andcc parm_b,31,%g0
	bne   L$I_mod_32
	nop 
/* shft word right */



	srl parm_b,5,parm_b
	sub len_a,parm_b,len_c
	st len_c,[parm_c]
	sll parm_b,2,parm_b
	add parm_a,parm_b,parm_a
	tst len_c
	be L$B_cp2
	nop
	L$C_cp2 :
	inc 4,parm_c
	inc 4,parm_a
	ld [parm_a],tmp1
	st tmp1,[parm_c]
	deccc len_c
	bne  L$C_cp2
	nop
	L$B_cp2 :






	
	ba L$B_mod_32
	nop ;
	L$I_mod_32 :

/* shft bits right */


	and parm_b,31,right
	set 32,left
	sub left,right,left

	srl parm_b,5,parm_b

/* exit if abs(b) is to big */

	subcc len_a,parm_b ,len_c
	bg   L$I_toshort
	nop 
	clr len_c
	st len_c,[parm_c]
	b L$B_end
	nop
	L$I_toshort :
	L$B_toshort :

	st len_c,[parm_c]

	sll parm_b,2,tmp1
	add parm_a,tmp1,parm_a
	inc 4,parm_a

	ld [parm_a],rw
	subcc len_c,1,tmp1
	be L$B_shr
	nop
	L$C_shr :
	inc 4,parm_a
	inc 4,parm_c
	ld [parm_a],lw
	sll lw,left,nw
	srl rw,right,rw
	or nw,rw,nw
	st nw,[parm_c]
	mov lw,rw
	deccc tmp1
	bne  L$C_shr
	nop
	L$B_shr :

	srl rw,right,nw

/* dec length if the highest word is equal 0 */

	tst nw
	be   L$I_less
	nop 
	inc 4,parm_c
	st nw,[parm_c]
	
	ba L$B_less
	nop ;
	L$I_less :
	dec len_c
	st len_c,[save_c]
	L$B_less :





	L$B_mod_32 :

	L$B_sign :
L$B_end:
	EPILOGUE
