/*
 * $Id: sec_conf.h,v 1.11 1995/03/24 08:02:42 surkau Exp $
 *
 * $Log: sec_conf.h,v $
# Revision 1.8  1995/01/17  10:12:33  giehl
# Define ICR2 added
#
# Revision 1.7  1995/01/09  12:44:57  surkau
# MSC
#
# Revision 1.6  1995/01/09  12:38:18  surkau
# MicroSoft C
#
# Revision 1.5  1994/11/23  12:41:59  surkau
# new macros SIZEOFINT and SIZEOFLONG
#
# Revision 1.4  1994/11/02  10:44:39  surkau
# Header replaced by Id
#
# Revision 1.3  1994/11/02  09:39:08  surkau
# SecuDE-4.4.a0
#
# Revision 1.2  1994/11/01  10:59:52  surkau
# dos-version
#
 */
/********************************************************************
 * Copyright (C) 1994, GMD. All rights reserved.                    *
 *                                                                  *
 *                                                                  *
 *                         NOTICE                                   *
 *                                                                  *
 *    Acquisition, use, and distribution of this module             *
 *    and related materials are subject to restrictions             *
 *    mentioned in each volume of the documentation.                *
 *                                                                  *
 ********************************************************************/

/*   config file for MS-DOS   */

#ifndef _SEC_CONFIG_
#define _SEC_CONFIG_

#include "config.h"

/*
 * Arithmetic
 */

#ifndef SIZEOFINT               /* this is the size of int in bits. 
                                   Possible values: 16, 32                        */
#ifdef MSC
#define SIZEOFINT 16
#else
#define SIZEOFINT 32
#endif

#endif
#ifndef SIZEOFLONG              /* this is the size of long in bits.
                                   Possible values: 32, 64                        */
#define SIZEOFLONG 32
#endif

#define LITTLE_ENDIAN        /* LITTLE_ENDIAN architecture (e.g. Intel):       */

                                               
/*
 * AFDB Directory
 */

#define AFDBFILE "C:\\secude\\etc\\af-db\\"  /* pathname of the AFDB Directory    */
#define ALIASDIR "C:\\secude\\etc\\af-db\\"  /* location of the system alias file  */


/*
 * Miscellaneous
 */

#ifdef MSC

typedef char *		caddr_t;
typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned long	u_long;

#define MACRO_SEP_LIKE_STDC

#endif

#define NDBM                    /* ndbm database functions are available:         */
#define GDBM                    /* ndbm database functions are used from          */
			        /* own gdbm installation:                         */

#define ICR1                    /* Use SecuDE with ISODE ICR1. If you use it      */
                                /* with Isode-8, ICR1 must be undefined           */
                                   
#undef  ICR2                    /* Use SecuDE with ISODE ICR2. If you use it      */
                                /* with Isode-8, ICR1 must be undefined. If       */
				/* you use it with ICR2, ICR1 must also be        */ 
				/* defined					  */

#ifndef	_CONFIG_                /* This is the ISODE config.h                     */
#define	_CONFIG_

/*
 * The following are the ISODE ICR1 config.h definitions needed for the
 * integrated ISODE routines
 */

/* 
 * $Log: sec_conf.h,v $
 * Revision 1.11  1995/03/24  08:02:42  surkau
 * etc/af-db
 *
 * Revision 1.10  1995/03/13  15:51:46  surkau
 * *** empty log message ***
 *
 * Revision 1.9  1995/03/07  14:05:33  surkau
 * MS-DOS with ICR1
 *
# Revision 1.8  1995/01/17  10:12:33  giehl
# Define ICR2 added
#
# Revision 1.7  1995/01/09  12:44:57  surkau
# MSC
#
# Revision 1.6  1995/01/09  12:38:18  surkau
# MicroSoft C
#
# Revision 1.5  1994/11/23  12:41:59  surkau
# new macros SIZEOFINT and SIZEOFLONG
#
# Revision 1.4  1994/11/02  10:44:39  surkau
# Header replaced by Id
#
# Revision 1.3  1994/11/02  09:39:08  surkau
# SecuDE-4.4.a0
#
# Revision 1.2  1994/11/01  10:59:52  surkau
# dos-version
#
# Revision 1.1  1994/10/18  08:23:46  surkau
# Initial revision
#
 * Revision 10.0  1993/02/18  20:26:44  awy
 * Release IC-R1
 *
 */


#ifdef MSC
#define	BSD44			/* Berkeley UNIX */
#else
#define	BSD42			/* Berkeley UNIX */
#endif

#ifdef BSD42
# define BSD43			/*   4.3BSD or later */
# define SUNOS4			/*   Sun's enhancements (include 4.3BSD) */
# define SUNOS41		/*   SunOS 4.1sun stuff */
# undef BSD43_Tahoe		/*   4.3BSD Tahoe release */
# undef BSD44			/*   4.4BSD (not out yet) */
# undef OSX			/*   Olivetti's version */
# undef aiws			/*   AIX Workstation */
#endif /* BSD42 */

/***********************************************************************
 *
 * Now some feature that are variously implemented.
 *
 */

#define	WRITEV			/* has writev(2) system call*/
#define	GETDENTS		/* has getdirent(2) call */
#undef	SCANDIR			/* has scandir(3) & alphasort(3) */
#define	NFS			/* network filesystem -- has getdirentries */
#define TEMPNAM                 /* has tempnam (3) call */
#define	VSPRINTF		/* has vprintf(3s) routines */
#define	GETCWD			/* has getcwd(3) */

#endif /* _CONFIG_ */

#endif /* _SEC_CONFIG_ */
