/* ./src/pepsy/PKCS_tables.c */

static char *rcsid = "$Id: PKCS_tables.c,v 1.3 1994/11/02 10:44:39 surkau Exp $";

/* 
 *
 * $Id: PKCS_tables.c,v 1.3 1994/11/02 10:44:39 surkau Exp $
 *
 * $Log: PKCS_tables.c,v $
 *
 */
 
#include <stdio.h>
#include "PKCS-types.h"


# line 5 "pkcs.py"
	/* surrounding global definitions */
#include        "pkcs.h"

	extern OctetString   * e_ExtendedCertificateInfo();
	extern OctetString   * e_CertificationRequestInfo();

	static OctetString   * tmp_ostr1, * tmp_ostr2, * tmp_ostr3, * tmp_ostr4;
	static OctetString   * tmp_ostr5, * tmp_ostr6, * tmp_ostr7, * tmp_ostr8;
	static OctetString     save_modulus, save_pubex, save_privex, save_prime1;
	static OctetString     save_prime2, save_exp1, save_exp2, save_coeff;
	static OctetString   * nullostr = NULLOCTETSTRING;
	static int	       i;

extern caddr_t _ZptrtabPKCS[];	/* forward decl */

#define OFFSET(t,f)	((int ) &(((t *)0)->f))


#define AOFFSET(t,f)	((int ) (((t *)0)->f))

static ptpe et_RSAPrivateKeyPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[0] },
	{ UCODE, 0, 0, 0, (char **)&_ZptrtabPKCS[0] }, /* line 27 */
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[0] },
	{ INTEGER, OFFSET(RSAPrivateKey , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , modulus), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[2] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[2] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , pubex), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[4] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[4] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , privex), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[5] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[5] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , prime1), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[6] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[6] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , prime2), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[7] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[7] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , exp1), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[8] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[8] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , exp2), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[9] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[9] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , coeff), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[10] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[10] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[0] },
	{ UCODE, 1, 0, 0, (char **)&_ZptrtabPKCS[0] }, /* line 170 */
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[0] }
	};

static ptpe et_ExtendedCertificateOrCertificatePKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ SCHOICE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ SCTRL, OFFSET(ExtendedCertificateOrCertificate , choice), 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ EXTOBJ, OFFSET(ExtendedCertificateOrCertificate , un.cert), _ZCertificateSECAF, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[12] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[14] },
	{ OBJECT, OFFSET(ExtendedCertificateOrCertificate , un.extcert), _ZExtendedCertificatePKCS, FL_CONTEXT, (char **)&_ZptrtabPKCS[14] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[11] }
	};

static ptpe et_ExtendedCertificatesAndCertificatesPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[15] },
	{ SSETOF_START, 0, 17, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[15] },
	{ OBJECT, OFFSET(ExtendedCertificatesAndCertificates , element), _ZExtendedCertificateOrCertificatePKCS, 0, (char **)&_ZptrtabPKCS[15] },
	{ PE_END, OFFSET(ExtendedCertificatesAndCertificates , next), 0, 0, (char **)&_ZptrtabPKCS[15] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[15] }
	};

static ptpe et_ExtendedCertificateInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[16] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[16] },
	{ INTEGER, OFFSET(ExtendedCertificateInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(ExtendedCertificateInfo , cert), _ZCertificateSECAF, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTOBJ, OFFSET(ExtendedCertificateInfo , attributes), _ZSETOFAttributeSECIF, 0, (char **)&_ZptrtabPKCS[17] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[17] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[16] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[16] }
	};

static ptpe et_ExtendedCertificatePKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[19] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[19] },
	{ OBJECT, OFFSET(ExtendedCertificate , extcertinfo), _ZExtendedCertificateInfoPKCS, 0, (char **)&_ZptrtabPKCS[20] },
	{ EXTOBJ, OFFSET(ExtendedCertificate , sig), _ZTAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTOBJ, OFFSET(ExtendedCertificate , sig), _ZTBitStringSEC, 0, (char **)&_ZptrtabPKCS[22] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[22] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[19] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[19] }
	};

static ptpe et_IssuerAndSerialNumberPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[23] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[23] },
	{ EXTOBJ, OFFSET(IssuerAndSerialNumber , issuer), _ZNameSECIF, 0, (char **)&_ZptrtabPKCS[24] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[24] },
	{ EXTOBJ, OFFSET(IssuerAndSerialNumber , serialnumber), _ZOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[25] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[25] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[23] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[23] }
	};

static ptpe et_ContentInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[26] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[26] },
	{ OBJID, OFFSET(ContentInfo , contentType), 6, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[27] },
	{ UCODE, 2, 0, 0, (char **)&_ZptrtabPKCS[27] }, /* line 370 */
	{ BOPTIONAL, 4, 0, FL_USELECT, (char **)&_ZptrtabPKCS[28]},
	{ ETAG, 0, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[28] },
	{ SCHOICE_START, 0, 0, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[28] },
	{ SCTRL, 3, 0, FL_USELECT, (char **)&_ZptrtabPKCS[28] },
	{ EXTOBJ, OFFSET(ContentInfo , un.data), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[29] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[29] },
	{ OBJECT, OFFSET(ContentInfo , un.signedData), _ZSignedDataPKCS, 0, (char **)&_ZptrtabPKCS[30] },
	{ OBJECT, OFFSET(ContentInfo , un.envelopedData), _ZEnvelopedDataPKCS, 0, (char **)&_ZptrtabPKCS[31] },
	{ OBJECT, OFFSET(ContentInfo , un.signedAndEnvelopedData), _ZSignedAndEnvelopedDataPKCS, 0, (char **)&_ZptrtabPKCS[32] },
	{ OBJECT, OFFSET(ContentInfo , un.digestedData), _ZDigestedDataPKCS, 0, (char **)&_ZptrtabPKCS[33] },
	{ OBJECT, OFFSET(ContentInfo , un.encryptedData), _ZEncryptedDataPKCS, 0, (char **)&_ZptrtabPKCS[34] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[28] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[26] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[26] }
	};

static ptpe et_SignerInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[35] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[35] },
	{ INTEGER, OFFSET(SignerInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(SignerInfo , issuerandserial), _ZIssuerAndSerialNumberPKCS, 0, (char **)&_ZptrtabPKCS[36] },
	{ EXTOBJ, OFFSET(SignerInfo , digestAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[37] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[37] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[38] },
	{ EXTOBJ, OFFSET(SignerInfo , authAttributes), _ZSETOFAttributeSECIF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[38] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[38] },
	{ EXTOBJ, OFFSET(SignerInfo , digencAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[39] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[39] },
	{ EXTOBJ, OFFSET(SignerInfo , encryptedDigest), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[40] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[40] },
	{ IMP_OBJ, 0, 1, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[41] },
	{ EXTOBJ, OFFSET(SignerInfo , unauthAttributes), _ZSETOFAttributeSECIF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[41] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[41] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[35] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[35] }
	};

static ptpe et_SignerInfosPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[42] },
	{ SSETOF_START, 0, 17, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[42] },
	{ OBJECT, OFFSET(SignerInfos , element), _ZSignerInfoPKCS, 0, (char **)&_ZptrtabPKCS[42] },
	{ PE_END, OFFSET(SignerInfos , next), 0, 0, (char **)&_ZptrtabPKCS[42] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[42] }
	};

static ptpe et_RecipientInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[43] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[43] },
	{ INTEGER, OFFSET(RecipientInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(RecipientInfo , issuerandserial), _ZIssuerAndSerialNumberPKCS, 0, (char **)&_ZptrtabPKCS[36] },
	{ EXTOBJ, OFFSET(RecipientInfo , keyencAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[44] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[44] },
	{ EXTOBJ, OFFSET(RecipientInfo , encryptedKey), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[45] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[45] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[43] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[43] }
	};

static ptpe et_RecipientInfosPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[46] },
	{ SSETOF_START, 0, 17, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[46] },
	{ OBJECT, OFFSET(RecipientInfos , element), _ZRecipientInfoPKCS, 0, (char **)&_ZptrtabPKCS[46] },
	{ PE_END, OFFSET(RecipientInfos , next), 0, 0, (char **)&_ZptrtabPKCS[46] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[46] }
	};

static ptpe et_EncryptedContentInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[47] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[47] },
	{ OBJID, OFFSET(EncryptedContentInfo , contentType), 6, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[27] },
	{ EXTOBJ, OFFSET(EncryptedContentInfo , contentencAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[48] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[48] },
	{ OCTET_PTR, OFFSET(EncryptedContentInfo , encryptedContent.octets), 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[49] },
	{ OCTET_LEN, OFFSET(EncryptedContentInfo , encryptedContent.noctets), 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[49] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[47] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[47] }
	};

static ptpe et_SignedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[50] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[50] },
	{ INTEGER, OFFSET(SignedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(SignedData , digestAlgorithms), _ZSETOFAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[51] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[51] },
	{ OBJECT, OFFSET(SignedData , contentInfo), _ZContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[52] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ OBJECT, OFFSET(SignedData , certificates), _ZExtendedCertificatesAndCertificatesPKCS, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ IMP_OBJ, 0, 1, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTOBJ, OFFSET(SignedData , crls), _ZSETOFCRLSECAF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[54] },
	{ OBJECT, OFFSET(SignedData , signerInfos), _ZSignerInfosPKCS, 0, (char **)&_ZptrtabPKCS[55] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[50] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[50] }
	};

static ptpe et_EnvelopedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[56] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[56] },
	{ INTEGER, OFFSET(EnvelopedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(EnvelopedData , recipientInfos), _ZRecipientInfosPKCS, 0, (char **)&_ZptrtabPKCS[57] },
	{ OBJECT, OFFSET(EnvelopedData , encryptedContInfo), _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[56] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[56] }
	};

static ptpe et_SignedAndEnvelopedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[59] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[59] },
	{ INTEGER, OFFSET(SignedAndEnvelopedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , recipientInfos), _ZRecipientInfosPKCS, 0, (char **)&_ZptrtabPKCS[57] },
	{ EXTOBJ, OFFSET(SignedAndEnvelopedData , digestAIs), _ZSETOFAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[51] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[51] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , encryptedContInfo), _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , certificates), _ZExtendedCertificatesAndCertificatesPKCS, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ IMP_OBJ, 0, 1, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTOBJ, OFFSET(SignedAndEnvelopedData , crls), _ZSETOFCRLSECAF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[54] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , signerInfos), _ZSignerInfosPKCS, 0, (char **)&_ZptrtabPKCS[55] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[59] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[59] }
	};

static ptpe et_DigestedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[60] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[60] },
	{ INTEGER, OFFSET(DigestedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(DigestedData , digestAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[37] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[37] },
	{ OBJECT, OFFSET(DigestedData , contentInfo), _ZContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[52] },
	{ EXTOBJ, OFFSET(DigestedData , digest), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[61] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[61] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[60] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[60] }
	};

static ptpe et_EncryptedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[62] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[62] },
	{ INTEGER, OFFSET(EncryptedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(EncryptedData , encryptedContInfo), _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[62] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[62] }
	};

static ptpe et_CertificationRequestInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[63] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[63] },
	{ INTEGER, OFFSET(CertificationRequestInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(CertificationRequestInfo , subject), _ZNameSECIF, 0, (char **)&_ZptrtabPKCS[64] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[64] },
	{ EXTOBJ, OFFSET(CertificationRequestInfo , subjectPK), _ZKeyInfoSEC, 0, (char **)&_ZptrtabPKCS[65] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[65] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[17] },
	{ EXTOBJ, OFFSET(CertificationRequestInfo , attributes), _ZSETOFAttributeSECIF, FL_CONTEXT, (char **)&_ZptrtabPKCS[17] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[17] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[63] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[63] }
	};

static ptpe et_CertificationRequestPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[66] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[66] },
	{ OBJECT, OFFSET(CertificationRequest , certreqinfo), _ZCertificationRequestInfoPKCS, 0, (char **)&_ZptrtabPKCS[67] },
	{ EXTOBJ, OFFSET(CertificationRequest , sig), _ZTAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTOBJ, OFFSET(CertificationRequest , sig), _ZTBitStringSEC, 0, (char **)&_ZptrtabPKCS[22] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[22] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[66] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[66] }
	};

static ptpe dt_RSAPrivateKeyPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[0] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[0] },
	{ MEMALLOC, 0, sizeof (RSAPrivateKey ), 0, (char **)&_ZptrtabPKCS[0] },
	{ INTEGER, OFFSET(RSAPrivateKey , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , modulus), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[2] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[2] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , pubex), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[4] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[4] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , privex), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[5] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[5] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , prime1), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[6] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[6] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , prime2), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[7] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[7] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , exp1), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[8] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[8] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , exp2), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[9] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[9] },
	{ SEXTOBJ, OFFSET(RSAPrivateKey , coeff), _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[10] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[10] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[0] },
	{ UCODE, 0, 0, 0, (char **)&_ZptrtabPKCS[0] }, /* line 212 */
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[0] }
	};

static ptpe dt_ExtendedCertificateOrCertificatePKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ SCHOICE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ MEMALLOC, 0, sizeof (ExtendedCertificateOrCertificate ), 0, (char **)&_ZptrtabPKCS[11] },
	{ SCTRL, OFFSET(ExtendedCertificateOrCertificate , choice), 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ EXTOBJ, OFFSET(ExtendedCertificateOrCertificate , un.cert), _ZCertificateSECAF, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[12] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[14] },
	{ OBJECT, OFFSET(ExtendedCertificateOrCertificate , un.extcert), _ZExtendedCertificatePKCS, FL_CONTEXT, (char **)&_ZptrtabPKCS[14] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[11] }
	};

static ptpe dt_ExtendedCertificatesAndCertificatesPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[15] },
	{ SSETOF_START, 0, 17, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[15] },
	{ MEMALLOC, 0, sizeof (ExtendedCertificatesAndCertificates ), 0, (char **)&_ZptrtabPKCS[15] },
	{ OBJECT, OFFSET(ExtendedCertificatesAndCertificates , element), _ZExtendedCertificateOrCertificatePKCS, 0, (char **)&_ZptrtabPKCS[15] },
	{ PE_END, OFFSET(ExtendedCertificatesAndCertificates , next), 0, 0, (char **)&_ZptrtabPKCS[15] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[15] }
	};

static ptpe dt_ExtendedCertificateInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[16] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[16] },
	{ MEMALLOC, 0, sizeof (ExtendedCertificateInfo ), 0, (char **)&_ZptrtabPKCS[16] },
	{ INTEGER, OFFSET(ExtendedCertificateInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(ExtendedCertificateInfo , cert), _ZCertificateSECAF, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTOBJ, OFFSET(ExtendedCertificateInfo , attributes), _ZSETOFAttributeSECIF, 0, (char **)&_ZptrtabPKCS[17] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[17] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[16] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[16] }
	};

static ptpe dt_ExtendedCertificatePKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[19] },
	{ UCODE, 1, 0, 0, (char **)&_ZptrtabPKCS[19] }, /* line 322 */
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[19] },
	{ MEMALLOC, 0, sizeof (ExtendedCertificate ), 0, (char **)&_ZptrtabPKCS[19] },
	{ OBJECT, OFFSET(ExtendedCertificate , extcertinfo), _ZExtendedCertificateInfoPKCS, 0, (char **)&_ZptrtabPKCS[20] },
	{ UCODE, 2, 0, 0, (char **)&_ZptrtabPKCS[20] }, /* line 337 */
	{ EXTOBJ, OFFSET(ExtendedCertificate , sig), _ZTAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTOBJ, OFFSET(ExtendedCertificate , sig), _ZTBitStringSEC, 0, (char **)&_ZptrtabPKCS[22] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[22] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[19] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[19] }
	};

static ptpe dt_IssuerAndSerialNumberPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[23] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[23] },
	{ MEMALLOC, 0, sizeof (IssuerAndSerialNumber ), 0, (char **)&_ZptrtabPKCS[23] },
	{ EXTOBJ, OFFSET(IssuerAndSerialNumber , issuer), _ZNameSECIF, 0, (char **)&_ZptrtabPKCS[24] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[24] },
	{ EXTOBJ, OFFSET(IssuerAndSerialNumber , serialnumber), _ZOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[25] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[25] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[23] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[23] }
	};

static ptpe dt_ContentInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[26] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[26] },
	{ MEMALLOC, 0, sizeof (ContentInfo ), 0, (char **)&_ZptrtabPKCS[26] },
	{ OBJID, OFFSET(ContentInfo , contentType), 6, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[27] },
	{ UCODE, 3, 0, 0, (char **)&_ZptrtabPKCS[27] }, /* line 389 */
	{ BOPTIONAL, -1, 0, FL_USELECT, (char **)&_ZptrtabPKCS[28]},
	{ ETAG, 0, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[28] },
	{ SCHOICE_START, 0, 0, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[28] },
	{ SCTRL, 4, 0, FL_USELECT, (char **)&_ZptrtabPKCS[28] },
	{ EXTOBJ, OFFSET(ContentInfo , un.data), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[29] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[29] },
	{ UCODE, 5, 0, 0, (char **)&_ZptrtabPKCS[29] }, /* line 410 */
	{ OBJECT, OFFSET(ContentInfo , un.signedData), _ZSignedDataPKCS, 0, (char **)&_ZptrtabPKCS[30] },
	{ UCODE, 6, 0, 0, (char **)&_ZptrtabPKCS[30] }, /* line 418 */
	{ OBJECT, OFFSET(ContentInfo , un.envelopedData), _ZEnvelopedDataPKCS, 0, (char **)&_ZptrtabPKCS[31] },
	{ UCODE, 7, 0, 0, (char **)&_ZptrtabPKCS[31] }, /* line 426 */
	{ OBJECT, OFFSET(ContentInfo , un.signedAndEnvelopedData), _ZSignedAndEnvelopedDataPKCS, 0, (char **)&_ZptrtabPKCS[32] },
	{ UCODE, 8, 0, 0, (char **)&_ZptrtabPKCS[32] }, /* line 434 */
	{ OBJECT, OFFSET(ContentInfo , un.digestedData), _ZDigestedDataPKCS, 0, (char **)&_ZptrtabPKCS[33] },
	{ UCODE, 9, 0, 0, (char **)&_ZptrtabPKCS[33] }, /* line 442 */
	{ OBJECT, OFFSET(ContentInfo , un.encryptedData), _ZEncryptedDataPKCS, 0, (char **)&_ZptrtabPKCS[34] },
	{ UCODE, 10, 0, 0, (char **)&_ZptrtabPKCS[34] }, /* line 450 */
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[28] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[26] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[26] }
	};

static ptpe dt_SignerInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[35] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[35] },
	{ MEMALLOC, 0, sizeof (SignerInfo ), 0, (char **)&_ZptrtabPKCS[35] },
	{ INTEGER, OFFSET(SignerInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(SignerInfo , issuerandserial), _ZIssuerAndSerialNumberPKCS, 0, (char **)&_ZptrtabPKCS[36] },
	{ EXTOBJ, OFFSET(SignerInfo , digestAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[37] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[37] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[38] },
	{ EXTOBJ, OFFSET(SignerInfo , authAttributes), _ZSETOFAttributeSECIF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[38] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[38] },
	{ EXTOBJ, OFFSET(SignerInfo , digencAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[39] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[39] },
	{ EXTOBJ, OFFSET(SignerInfo , encryptedDigest), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[40] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[40] },
	{ IMP_OBJ, 0, 1, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[41] },
	{ EXTOBJ, OFFSET(SignerInfo , unauthAttributes), _ZSETOFAttributeSECIF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[41] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[41] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[35] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[35] }
	};

static ptpe dt_SignerInfosPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[42] },
	{ SSETOF_START, 0, 17, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[42] },
	{ MEMALLOC, 0, sizeof (SignerInfos ), 0, (char **)&_ZptrtabPKCS[42] },
	{ OBJECT, OFFSET(SignerInfos , element), _ZSignerInfoPKCS, 0, (char **)&_ZptrtabPKCS[42] },
	{ PE_END, OFFSET(SignerInfos , next), 0, 0, (char **)&_ZptrtabPKCS[42] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[42] }
	};

static ptpe dt_RecipientInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[43] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[43] },
	{ MEMALLOC, 0, sizeof (RecipientInfo ), 0, (char **)&_ZptrtabPKCS[43] },
	{ INTEGER, OFFSET(RecipientInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(RecipientInfo , issuerandserial), _ZIssuerAndSerialNumberPKCS, 0, (char **)&_ZptrtabPKCS[36] },
	{ EXTOBJ, OFFSET(RecipientInfo , keyencAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[44] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[44] },
	{ EXTOBJ, OFFSET(RecipientInfo , encryptedKey), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[45] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[45] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[43] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[43] }
	};

static ptpe dt_RecipientInfosPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[46] },
	{ SSETOF_START, 0, 17, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[46] },
	{ MEMALLOC, 0, sizeof (RecipientInfos ), 0, (char **)&_ZptrtabPKCS[46] },
	{ OBJECT, OFFSET(RecipientInfos , element), _ZRecipientInfoPKCS, 0, (char **)&_ZptrtabPKCS[46] },
	{ PE_END, OFFSET(RecipientInfos , next), 0, 0, (char **)&_ZptrtabPKCS[46] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[46] }
	};

static ptpe dt_EncryptedContentInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[47] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[47] },
	{ MEMALLOC, 0, sizeof (EncryptedContentInfo ), 0, (char **)&_ZptrtabPKCS[47] },
	{ OBJID, OFFSET(EncryptedContentInfo , contentType), 6, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[27] },
	{ EXTOBJ, OFFSET(EncryptedContentInfo , contentencAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[48] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[48] },
	{ OCTET_PTR, OFFSET(EncryptedContentInfo , encryptedContent.octets), 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[49] },
	{ OCTET_LEN, OFFSET(EncryptedContentInfo , encryptedContent.noctets), 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[49] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[47] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[47] }
	};

static ptpe dt_SignedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[50] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[50] },
	{ MEMALLOC, 0, sizeof (SignedData ), 0, (char **)&_ZptrtabPKCS[50] },
	{ INTEGER, OFFSET(SignedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(SignedData , digestAlgorithms), _ZSETOFAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[51] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[51] },
	{ OBJECT, OFFSET(SignedData , contentInfo), _ZContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[52] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ OBJECT, OFFSET(SignedData , certificates), _ZExtendedCertificatesAndCertificatesPKCS, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ IMP_OBJ, 0, 1, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTOBJ, OFFSET(SignedData , crls), _ZSETOFCRLSECAF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[54] },
	{ OBJECT, OFFSET(SignedData , signerInfos), _ZSignerInfosPKCS, 0, (char **)&_ZptrtabPKCS[55] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[50] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[50] }
	};

static ptpe dt_EnvelopedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[56] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[56] },
	{ MEMALLOC, 0, sizeof (EnvelopedData ), 0, (char **)&_ZptrtabPKCS[56] },
	{ INTEGER, OFFSET(EnvelopedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(EnvelopedData , recipientInfos), _ZRecipientInfosPKCS, 0, (char **)&_ZptrtabPKCS[57] },
	{ OBJECT, OFFSET(EnvelopedData , encryptedContInfo), _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[56] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[56] }
	};

static ptpe dt_SignedAndEnvelopedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[59] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[59] },
	{ MEMALLOC, 0, sizeof (SignedAndEnvelopedData ), 0, (char **)&_ZptrtabPKCS[59] },
	{ INTEGER, OFFSET(SignedAndEnvelopedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , recipientInfos), _ZRecipientInfosPKCS, 0, (char **)&_ZptrtabPKCS[57] },
	{ EXTOBJ, OFFSET(SignedAndEnvelopedData , digestAIs), _ZSETOFAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[51] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[51] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , encryptedContInfo), _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , certificates), _ZExtendedCertificatesAndCertificatesPKCS, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[53] },
	{ IMP_OBJ, 0, 1, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTOBJ, OFFSET(SignedAndEnvelopedData , crls), _ZSETOFCRLSECAF, FL_CONTEXT|FL_OPTIONAL, (char **)&_ZptrtabPKCS[54] },
	{ EXTMOD, 13, 0, 0, (char **)&_ZptrtabPKCS[54] },
	{ OBJECT, OFFSET(SignedAndEnvelopedData , signerInfos), _ZSignerInfosPKCS, 0, (char **)&_ZptrtabPKCS[55] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[59] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[59] }
	};

static ptpe dt_DigestedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[60] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[60] },
	{ MEMALLOC, 0, sizeof (DigestedData ), 0, (char **)&_ZptrtabPKCS[60] },
	{ INTEGER, OFFSET(DigestedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(DigestedData , digestAI), _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[37] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[37] },
	{ OBJECT, OFFSET(DigestedData , contentInfo), _ZContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[52] },
	{ EXTOBJ, OFFSET(DigestedData , digest), _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[61] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[61] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[60] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[60] }
	};

static ptpe dt_EncryptedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[62] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[62] },
	{ MEMALLOC, 0, sizeof (EncryptedData ), 0, (char **)&_ZptrtabPKCS[62] },
	{ INTEGER, OFFSET(EncryptedData , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, OFFSET(EncryptedData , encryptedContInfo), _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[62] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[62] }
	};

static ptpe dt_CertificationRequestInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[63] },
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[63] },
	{ MEMALLOC, 0, sizeof (CertificationRequestInfo ), 0, (char **)&_ZptrtabPKCS[63] },
	{ INTEGER, OFFSET(CertificationRequestInfo , version), 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, OFFSET(CertificationRequestInfo , subject), _ZNameSECIF, 0, (char **)&_ZptrtabPKCS[64] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[64] },
	{ EXTOBJ, OFFSET(CertificationRequestInfo , subjectPK), _ZKeyInfoSEC, 0, (char **)&_ZptrtabPKCS[65] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[65] },
	{ IMP_OBJ, 0, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[17] },
	{ EXTOBJ, OFFSET(CertificationRequestInfo , attributes), _ZSETOFAttributeSECIF, FL_CONTEXT, (char **)&_ZptrtabPKCS[17] },
	{ EXTMOD, 18, 0, 0, (char **)&_ZptrtabPKCS[17] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[63] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[63] }
	};

static ptpe dt_CertificationRequestPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[66] },
	{ UCODE, 12, 0, 0, (char **)&_ZptrtabPKCS[66] }, /* line 654 */
	{ SSEQ_START, 0, 16, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[66] },
	{ MEMALLOC, 0, sizeof (CertificationRequest ), 0, (char **)&_ZptrtabPKCS[66] },
	{ OBJECT, OFFSET(CertificationRequest , certreqinfo), _ZCertificationRequestInfoPKCS, 0, (char **)&_ZptrtabPKCS[67] },
	{ UCODE, 13, 0, 0, (char **)&_ZptrtabPKCS[67] }, /* line 669 */
	{ EXTOBJ, OFFSET(CertificationRequest , sig), _ZTAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTOBJ, OFFSET(CertificationRequest , sig), _ZTBitStringSEC, 0, (char **)&_ZptrtabPKCS[22] },
	{ EXTMOD, 3, 0, 0, (char **)&_ZptrtabPKCS[22] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[66] },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[66] }
	};

static ptpe pt_RSAPrivateKeyPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[0] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[2] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[4] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[5] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[6] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[7] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[8] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[9] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ SEXTOBJ, 0, _ZTOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[10] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[0] }
	};

static ptpe pt_ExtendedCertificateOrCertificatePKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[11] },
	{ SCHOICE_START, -1, 0, 0, NULLVP },
	{ SCTRL, 0, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZCertificateSECAF, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTMOD, 13, 0, 0, NULLVP },
	{ IMP_OBJ, -1, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[14] },
	{ OBJECT, 0, _ZExtendedCertificatePKCS, FL_CONTEXT, (char **)&_ZptrtabPKCS[14] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[11] }
	};

static ptpe pt_ExtendedCertificatesAndCertificatesPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[15] },
	{ SSETOF_START, -1, 17, FL_UNIVERSAL, NULLVP },
	{ OBJECT, 0, _ZExtendedCertificateOrCertificatePKCS, 0, (char **)&_ZptrtabPKCS[11] },
	{ PE_END, OFFSET(ExtendedCertificatesAndCertificates , next), 0, 0 },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[15] }
	};

static ptpe pt_ExtendedCertificateInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[16] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, 0, _ZCertificateSECAF, 0, (char **)&_ZptrtabPKCS[12] },
	{ EXTMOD, 13, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZSETOFAttributeSECIF, 0, (char **)&_ZptrtabPKCS[17] },
	{ EXTMOD, 18, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[16] }
	};

static ptpe pt_ExtendedCertificatePKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[19] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ OBJECT, 0, _ZExtendedCertificateInfoPKCS, 0, (char **)&_ZptrtabPKCS[20] },
	{ EXTOBJ, 0, _ZTAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZTBitStringSEC, 0, (char **)&_ZptrtabPKCS[22] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[19] }
	};

static ptpe pt_IssuerAndSerialNumberPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[23] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ EXTOBJ, 0, _ZNameSECIF, 0, (char **)&_ZptrtabPKCS[24] },
	{ EXTMOD, 18, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZOURINTEGERSEC, 0, (char **)&_ZptrtabPKCS[25] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[23] }
	};

static ptpe pt_ContentInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[26] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ OBJID, -1, 6, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[27] },
	{ ETAG, -1, 0, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[28] },
	{ SCHOICE_START, -1, 0, FL_UNIVERSAL|FL_OPTIONAL, NULLVP },
	{ SCTRL, 0, 0, 0, (char **)&_ZptrtabPKCS[28] },
	{ EXTOBJ, 0, _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[29] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ OBJECT, 0, _ZSignedDataPKCS, 0, (char **)&_ZptrtabPKCS[30] },
	{ OBJECT, 0, _ZEnvelopedDataPKCS, 0, (char **)&_ZptrtabPKCS[31] },
	{ OBJECT, 0, _ZSignedAndEnvelopedDataPKCS, 0, (char **)&_ZptrtabPKCS[32] },
	{ OBJECT, 0, _ZDigestedDataPKCS, 0, (char **)&_ZptrtabPKCS[33] },
	{ OBJECT, 0, _ZEncryptedDataPKCS, 0, (char **)&_ZptrtabPKCS[34] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[26] }
	};

static ptpe pt_SignerInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[35] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, 0, _ZIssuerAndSerialNumberPKCS, 0, (char **)&_ZptrtabPKCS[36] },
	{ EXTOBJ, 0, _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[37] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ IMP_OBJ, -1, 0, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[38] },
	{ EXTOBJ, 0, _ZSETOFAttributeSECIF, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[38] },
	{ EXTMOD, 18, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[39] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[40] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ IMP_OBJ, -1, 1, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[41] },
	{ EXTOBJ, 0, _ZSETOFAttributeSECIF, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[41] },
	{ EXTMOD, 18, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[35] }
	};

static ptpe pt_SignerInfosPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[42] },
	{ SSETOF_START, -1, 17, FL_UNIVERSAL, NULLVP },
	{ OBJECT, 0, _ZSignerInfoPKCS, 0, (char **)&_ZptrtabPKCS[35] },
	{ PE_END, OFFSET(SignerInfos , next), 0, 0 },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[42] }
	};

static ptpe pt_RecipientInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[43] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, 0, _ZIssuerAndSerialNumberPKCS, 0, (char **)&_ZptrtabPKCS[36] },
	{ EXTOBJ, 0, _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[44] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[45] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[43] }
	};

static ptpe pt_RecipientInfosPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[46] },
	{ SSETOF_START, -1, 17, FL_UNIVERSAL, NULLVP },
	{ OBJECT, 0, _ZRecipientInfoPKCS, 0, (char **)&_ZptrtabPKCS[43] },
	{ PE_END, OFFSET(RecipientInfos , next), 0, 0 },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[46] }
	};

static ptpe pt_EncryptedContentInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[47] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ OBJID, -1, 6, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[27] },
	{ EXTOBJ, 0, _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[48] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ OCTET_PTR, -1, 0, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[49] },
	{ OCTET_LEN, -1, 0, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[49] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[47] }
	};

static ptpe pt_SignedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[50] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, 0, _ZSETOFAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[51] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ OBJECT, 0, _ZContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[52] },
	{ IMP_OBJ, -1, 0, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[53] },
	{ OBJECT, 0, _ZExtendedCertificatesAndCertificatesPKCS, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[53] },
	{ IMP_OBJ, -1, 1, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[54] },
	{ EXTOBJ, 0, _ZSETOFCRLSECAF, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[54] },
	{ EXTMOD, 13, 0, 0, NULLVP },
	{ OBJECT, 0, _ZSignerInfosPKCS, 0, (char **)&_ZptrtabPKCS[55] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[50] }
	};

static ptpe pt_EnvelopedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[56] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, 0, _ZRecipientInfosPKCS, 0, (char **)&_ZptrtabPKCS[57] },
	{ OBJECT, 0, _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[56] }
	};

static ptpe pt_SignedAndEnvelopedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[59] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, 0, _ZRecipientInfosPKCS, 0, (char **)&_ZptrtabPKCS[57] },
	{ EXTOBJ, 0, _ZSETOFAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[51] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ OBJECT, 0, _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ IMP_OBJ, -1, 0, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[53] },
	{ OBJECT, 0, _ZExtendedCertificatesAndCertificatesPKCS, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[53] },
	{ IMP_OBJ, -1, 1, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[54] },
	{ EXTOBJ, 0, _ZSETOFCRLSECAF, FL_CONTEXT|FL_OPTIONAL|FL_PRTAG, (char **)&_ZptrtabPKCS[54] },
	{ EXTMOD, 13, 0, 0, NULLVP },
	{ OBJECT, 0, _ZSignerInfosPKCS, 0, (char **)&_ZptrtabPKCS[55] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[59] }
	};

static ptpe pt_DigestedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[60] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, 0, _ZAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[37] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ OBJECT, 0, _ZContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[52] },
	{ EXTOBJ, 0, _ZOctetStringSEC, 0, (char **)&_ZptrtabPKCS[61] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[60] }
	};

static ptpe pt_EncryptedDataPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[62] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ OBJECT, 0, _ZEncryptedContentInfoPKCS, 0, (char **)&_ZptrtabPKCS[58] },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[62] }
	};

static ptpe pt_CertificationRequestInfoPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[63] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ INTEGER, -1, 2, FL_UNIVERSAL, (char **)&_ZptrtabPKCS[1] },
	{ EXTOBJ, 0, _ZNameSECIF, 0, (char **)&_ZptrtabPKCS[64] },
	{ EXTMOD, 18, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZKeyInfoSEC, 0, (char **)&_ZptrtabPKCS[65] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ IMP_OBJ, -1, 0, FL_CONTEXT, (char **)&_ZptrtabPKCS[17] },
	{ EXTOBJ, 0, _ZSETOFAttributeSECIF, FL_CONTEXT, (char **)&_ZptrtabPKCS[17] },
	{ EXTMOD, 18, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[63] }
	};

static ptpe pt_CertificationRequestPKCS[] = {
	{ PE_START, 0, 0, 0, (char **)&_ZptrtabPKCS[66] },
	{ SSEQ_START, -1, 16, FL_UNIVERSAL, NULLVP },
	{ OBJECT, 0, _ZCertificationRequestInfoPKCS, 0, (char **)&_ZptrtabPKCS[67] },
	{ EXTOBJ, 0, _ZTAlgorithmIdentifierSEC, 0, (char **)&_ZptrtabPKCS[21] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ EXTOBJ, 0, _ZTBitStringSEC, 0, (char **)&_ZptrtabPKCS[22] },
	{ EXTMOD, 3, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, NULLVP },
	{ PE_END, 0, 0, 0, (char **)&_ZptrtabPKCS[66] }
	};


/*VARARGS*/
static	int
efn_PKCS(__p, ppe, _Zp)
caddr_t	__p;
PE	*ppe;
ptpe	*_Zp;
{
		
	/* 5 cases */
    switch(_Zp->pe_ucode) {

#define parm	((RSAPrivateKey * )__p)
	case 0: /*  */
		{
# line 27 "pkcs.py"


	tmp_ostr1 = tmp_ostr2 = tmp_ostr3 = tmp_ostr4 = NULLOCTETSTRING;
	tmp_ostr5 = tmp_ostr6 = tmp_ostr7 = tmp_ostr8 = NULLOCTETSTRING;

	if(! nullostr){
		nullostr = aux_new_OctetString(1);
		nullostr->octets[0] = 0x00;
	}

	if ((parm->modulus.noctets == 0) || (parm->pubex.noctets == 0) ||
	    (parm->privex.noctets == 0) || (parm->prime1.noctets == 0) ||
	    (parm->prime2.noctets == 0) || (parm->exp1.noctets == 0) ||
	    (parm->exp2.noctets == 0) || (parm->coeff.noctets == 0))
		return(NOTOK);

	if(parm->modulus.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr1 = aux_concatenate_OctetString(nullostr, &parm->modulus);

		/* Save values of parm->modulus */
		save_modulus.noctets = parm->modulus.noctets;
		save_modulus.octets = parm->modulus.octets;
		parm->modulus.noctets = tmp_ostr1->noctets;
		parm->modulus.octets = tmp_ostr1->octets;
	}

	if(parm->pubex.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr2 = aux_concatenate_OctetString(nullostr, &parm->pubex);

		/* Save values of parm->pubex */
		save_pubex.noctets = parm->pubex.noctets;
		save_pubex.octets = parm->pubex.octets;
		parm->pubex.noctets = tmp_ostr2->noctets;
		parm->pubex.octets = tmp_ostr2->octets;
	}

	if(parm->privex.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr3 = aux_concatenate_OctetString(nullostr, &parm->privex);

		/* Save values of parm->privex */
		save_privex.noctets = parm->privex.noctets;
		save_privex.octets = parm->privex.octets;
		parm->privex.noctets = tmp_ostr3->noctets;
		parm->privex.octets = tmp_ostr3->octets;
	}

	if(parm->prime1.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr4 = aux_concatenate_OctetString(nullostr, &parm->prime1);

		/* Save values of parm->prime1 */
		save_prime1.noctets = parm->prime1.noctets;
		save_prime1.octets = parm->prime1.octets;
		parm->prime1.noctets = tmp_ostr4->noctets;
		parm->prime1.octets = tmp_ostr4->octets;
	}

	if(parm->prime2.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr5 = aux_concatenate_OctetString(nullostr, &parm->prime2);

		/* Save values of parm->prime2 */
		save_prime2.noctets = parm->prime2.noctets;
		save_prime2.octets = parm->prime2.octets;
		parm->prime2.noctets = tmp_ostr5->noctets;
		parm->prime2.octets = tmp_ostr5->octets;
	}

	if(parm->exp1.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr6 = aux_concatenate_OctetString(nullostr, &parm->exp1);

		/* Save values of parm->exp1 */
		save_exp1.noctets = parm->exp1.noctets;
		save_exp1.octets = parm->exp1.octets;
		parm->exp1.noctets = tmp_ostr6->noctets;
		parm->exp1.octets = tmp_ostr6->octets;
	}

	if(parm->exp2.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr7 = aux_concatenate_OctetString(nullostr, &parm->exp2);

		/* Save values of parm->exp2 */
		save_exp2.noctets = parm->exp2.noctets;
		save_exp2.octets = parm->exp2.octets;
		parm->exp2.noctets = tmp_ostr7->noctets;
		parm->exp2.octets = tmp_ostr7->octets;
	}

	if(parm->coeff.octets[0] & MSBITINBYTE){
	        /* Most significant bit in most significant byte is 1. */
		/* Therefore, leading 0 byte is required to conform to ASN-1 integer encoding */
		tmp_ostr8 = aux_concatenate_OctetString(nullostr, &parm->coeff);

		/* Save values of parm->coeff */
		save_coeff.noctets = parm->coeff.noctets;
		save_coeff.octets = parm->coeff.octets;
		parm->coeff.noctets = tmp_ostr8->noctets;
		parm->coeff.octets = tmp_ostr8->octets;
	}
	;
		}
	    break;

#undef parm

#define parm	((RSAPrivateKey * )__p)
	case 1: /*  */
		{
# line 170 "pkcs.py"

	if(tmp_ostr1) {
		aux_free_OctetString(&tmp_ostr1);
		parm->modulus.noctets = save_modulus.noctets;
		parm->modulus.octets = save_modulus.octets;
	}
	if(tmp_ostr2) {
		aux_free_OctetString(&tmp_ostr2);
		parm->pubex.noctets = save_pubex.noctets;
		parm->pubex.octets = save_pubex.octets;
	}
	if(tmp_ostr3) {
		aux_free_OctetString(&tmp_ostr3);
		parm->privex.noctets = save_privex.noctets;
		parm->privex.octets = save_privex.octets;
	}
	if(tmp_ostr4) {
		aux_free_OctetString(&tmp_ostr4);
		parm->prime1.noctets = save_prime1.noctets;
		parm->prime1.octets = save_prime1.octets;
	}
	if(tmp_ostr5) {
		aux_free_OctetString(&tmp_ostr5);
		parm->prime2.noctets = save_prime2.noctets;
		parm->prime2.octets = save_prime2.octets;
	}
	if(tmp_ostr6) {
		aux_free_OctetString(&tmp_ostr6);
		parm->exp1.noctets = save_exp1.noctets;
		parm->exp1.octets = save_exp1.octets;
	}
	if(tmp_ostr7) {
		aux_free_OctetString(&tmp_ostr7);
		parm->exp2.noctets = save_exp2.noctets;
		parm->exp2.octets = save_exp2.octets;
	}
	if(tmp_ostr8) {
		aux_free_OctetString(&tmp_ostr8);
		parm->coeff.noctets = save_coeff.noctets;
		parm->coeff.octets = save_coeff.octets;
	}
	;
		}
	    break;

#undef parm

#define parm	((ContentInfo * )__p)
	case 2: /*  */
		{
# line 370 "pkcs.py"

	    	parm->contentchoice = aux_ObjId2ContentType(parm->contentType);
	    	if (parm->contentchoice < 0){
            		advise (NULLCP, "parm->contentchoice has undefined value");
            		return NOTOK;
       		} 
		if (parm->contentchoice == 1)
			parm->un.data = (data_type *)(parm->content);
		else if (parm->contentchoice == 2)
			parm->un.signedData = (signedData_type *)(parm->content);
		else if (parm->contentchoice == 3)
			parm->un.envelopedData = (envelopedData_type *)(parm->content);
		else if (parm->contentchoice == 4)
			parm->un.signedAndEnvelopedData = (signedAndEnvelopedData_type *)(parm->content);
		else if (parm->contentchoice == 5)
			parm->un.digestedData = (digestedData_type *)(parm->content);
		else if (parm->contentchoice == 6)
			parm->un.encryptedData = (encryptedData_type *)(parm->content);
		;
		}
	    break;

#undef parm

#define parm	((ContentInfo * )__p)
	case 3: /*  */
		{
# line 406 "pkcs.py"
		return (parm->contentchoice);

		}
	    break;

#undef parm

#define parm	((ContentInfo * )__p)
	case 4: /*  */
		{
# line 456 "pkcs.py"
		return (parm->contentchoice > 0);

		}
	    break;

#undef parm
    default:
        return (pepsylose(NULLMODTYP, _Zp, *ppe, "enf_PKCS:Bad table entry: %d",
             _Zp->pe_ucode));
		}	/* switch */
    return (OK);
}

/*VARARGS*/
static	int
dfn_PKCS(__p, pe, _Zp, _val)
caddr_t	__p;
PE	pe;
ptpe	*_Zp;
int _val;
{
		
	/* 14 cases */
    switch(_Zp->pe_ucode) {

#define parm	((RSAPrivateKey ** )__p)
	case 0: /*  */
		{
# line 212 "pkcs.py"

	if(! ((*parm)->modulus.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->modulus.noctets - 1; i++)
			(*parm)->modulus.octets[i] = (*parm)->modulus.octets[i + 1];
		(*parm)->modulus.noctets -= 1;
		(*parm)->modulus.octets = (char *)realloc((*parm)->modulus.octets, (*parm)->modulus.noctets);
	}

	if(! ((*parm)->pubex.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->pubex.noctets - 1; i++)
			(*parm)->pubex.octets[i] = (*parm)->pubex.octets[i + 1];
		(*parm)->pubex.noctets -= 1;
		(*parm)->pubex.octets = (char *)realloc((*parm)->pubex.octets, (*parm)->pubex.noctets);
	}

	if(! ((*parm)->privex.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->privex.noctets - 1; i++)
			(*parm)->privex.octets[i] = (*parm)->privex.octets[i + 1];
		(*parm)->privex.noctets -= 1;
		(*parm)->privex.octets = (char *)realloc((*parm)->privex.octets, (*parm)->privex.noctets);
	}

	if(! ((*parm)->prime1.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->prime1.noctets - 1; i++)
			(*parm)->prime1.octets[i] = (*parm)->prime1.octets[i + 1];
		(*parm)->prime1.noctets -= 1;
		(*parm)->prime1.octets = (char *)realloc((*parm)->prime1.octets, (*parm)->prime1.noctets);
	}

	if(! ((*parm)->prime2.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->prime2.noctets - 1; i++)
			(*parm)->prime2.octets[i] = (*parm)->prime2.octets[i + 1];
		(*parm)->prime2.noctets -= 1;
		(*parm)->prime2.octets = (char *)realloc((*parm)->prime2.octets, (*parm)->prime2.noctets);
	}

	if(! ((*parm)->exp1.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->exp1.noctets - 1; i++)
			(*parm)->exp1.octets[i] = (*parm)->exp1.octets[i + 1];
		(*parm)->exp1.noctets -= 1;
		(*parm)->exp1.octets = (char *)realloc((*parm)->exp1.octets, (*parm)->exp1.noctets);
	}

	if(! ((*parm)->exp2.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->exp2.noctets - 1; i++)
			(*parm)->exp2.octets[i] = (*parm)->exp2.octets[i + 1];
		(*parm)->exp2.noctets -= 1;
		(*parm)->exp2.octets = (char *)realloc((*parm)->exp2.octets, (*parm)->exp2.noctets);
	}

	if(! ((*parm)->coeff.octets[0] | 0x00) ){    

		/* The bits of the most significant byte are all 0, so delete them */
		for ( i = 0; i < (*parm)->coeff.noctets - 1; i++)
			(*parm)->coeff.octets[i] = (*parm)->coeff.octets[i + 1];
		(*parm)->coeff.noctets -= 1;
		(*parm)->coeff.octets = (char *)realloc((*parm)->coeff.octets, (*parm)->coeff.noctets);
	}
	;
		}
	    break;

#undef parm

#define parm	((ExtendedCertificate ** )__p)
	case 1: /*  */
		{
# line 322 "pkcs.py"

        if (((*parm) = (ExtendedCertificate *) calloc (1, sizeof (ExtendedCertificate))) == ((ExtendedCertificate *) 0)) {
            	advise (NULLCP, "out of memory");
            	return NOTOK;
        }
	if (((*parm)->sig = (Signature *) malloc (sizeof (Signature))) == ((Signature *) 0)) {
		advise (NULLCP, "out of memory");
		return NOTOK;
	}
        ;
		}
	    break;

#undef parm

#define parm	((ExtendedCertificate ** )__p)
	case 2: /*  */
		{
# line 337 "pkcs.py"

		(*parm)->tbs_DERcode = e_ExtendedCertificateInfo((*parm)->extcertinfo);
		;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 3: /*  */
		{
# line 389 "pkcs.py"

		(*parm)->content = CNULL;
		(*parm)->un.data = (data_type *)0;
		(*parm)->un.signedData = (signedData_type *)0;
		(*parm)->un.envelopedData = (envelopedData_type *)0;
		(*parm)->un.signedAndEnvelopedData = (signedAndEnvelopedData_type *)0;
		(*parm)->un.digestedData = (digestedData_type *)0;
		(*parm)->un.encryptedData = (encryptedData_type *)0;
	    	(*parm)->contentchoice = aux_ObjId2ContentType((*parm)->contentType);
	    	if ((*parm)->contentchoice < 0){
            		advise (NULLCP, "parm->contentchoice has undefined value");
            		return NOTOK;
       		}
		;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 4: /*  */
		{
# line 406 "pkcs.py"
		((*parm)->contentchoice) = _val;

		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 11: /*  */
		{
# line 456 "pkcs.py"
(*parm)->contentchoice > 0;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 5: /*  */
		{
# line 410 "pkcs.py"

		  	(*parm)->content = (char *)aux_cpy_OctetString((*parm)->un.data);
		  	if((*parm)->un.data)
				aux_free_OctetString(&((*parm)->un.data));
     			;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 6: /*  */
		{
# line 418 "pkcs.py"

		  	(*parm)->content = (char *)aux_cpy_SignedData((*parm)->un.signedData);
		  	if((*parm)->un.signedData)
				aux_free_SignedData(&((*parm)->un.signedData));
    			;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 7: /*  */
		{
# line 426 "pkcs.py"

		  	(*parm)->content = (char *)aux_cpy_EnvelopedData((*parm)->un.envelopedData);
		  	if((*parm)->un.envelopedData)
				aux_free_EnvelopedData(&((*parm)->un.envelopedData));
     			;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 8: /*  */
		{
# line 434 "pkcs.py"

		  	(*parm)->content = (char *)aux_cpy_SignedAndEnvelopedData((*parm)->un.signedAndEnvelopedData);
		  	if((*parm)->un.signedAndEnvelopedData)
				aux_free_SignedAndEnvelopedData(&((*parm)->un.signedAndEnvelopedData));
     			;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 9: /*  */
		{
# line 442 "pkcs.py"

		  	(*parm)->content = (char *)aux_cpy_DigestedData((*parm)->un.digestedData);
		  	if((*parm)->un.digestedData)
				aux_free_DigestedData(&((*parm)->un.digestedData));
     			;
		}
	    break;

#undef parm

#define parm	((ContentInfo ** )__p)
	case 10: /*  */
		{
# line 450 "pkcs.py"

		  	(*parm)->content = (char *)aux_cpy_EncryptedData((*parm)->un.encryptedData);
		  	if((*parm)->un.encryptedData)
				aux_free_EncryptedData(&((*parm)->un.encryptedData));
     			;
		}
	    break;

#undef parm

#define parm	((CertificationRequest ** )__p)
	case 12: /*  */
		{
# line 654 "pkcs.py"

        if (((*parm) = (CertificationRequest *) calloc (1, sizeof (CertificationRequest))) == ((CertificationRequest *) 0)) {
            	advise (NULLCP, "out of memory");
            	return NOTOK;
        }
	if (((*parm)->sig = (Signature *) malloc (sizeof (Signature))) == ((Signature *) 0)) {
		advise (NULLCP, "out of memory");
		return NOTOK;
	}
        ;
		}
	    break;

#undef parm

#define parm	((CertificationRequest ** )__p)
	case 13: /*  */
		{
# line 669 "pkcs.py"

		(*parm)->tbs_DERcode = e_CertificationRequestInfo((*parm)->certreqinfo);
		;
		}
	    break;

#undef parm
    default:
        return (pepsylose(NULLMODTYP, _Zp, pe, "dnf_PKCS:Bad table entry: %d",
            _Zp->pe_ucode));
		}	/* switch */
    return (OK);
}
static ptpe *etabl[] = {
	et_RSAPrivateKeyPKCS,
	et_ExtendedCertificateOrCertificatePKCS,
	et_ExtendedCertificatesAndCertificatesPKCS,
	et_ExtendedCertificateInfoPKCS,
	et_ExtendedCertificatePKCS,
	et_IssuerAndSerialNumberPKCS,
	et_ContentInfoPKCS,
	et_SignerInfoPKCS,
	et_SignerInfosPKCS,
	et_RecipientInfoPKCS,
	et_RecipientInfosPKCS,
	et_EncryptedContentInfoPKCS,
	et_SignedDataPKCS,
	et_EnvelopedDataPKCS,
	et_SignedAndEnvelopedDataPKCS,
	et_DigestedDataPKCS,
	et_EncryptedDataPKCS,
	et_CertificationRequestInfoPKCS,
	et_CertificationRequestPKCS,
	};

static ptpe *dtabl[] = {
	dt_RSAPrivateKeyPKCS,
	dt_ExtendedCertificateOrCertificatePKCS,
	dt_ExtendedCertificatesAndCertificatesPKCS,
	dt_ExtendedCertificateInfoPKCS,
	dt_ExtendedCertificatePKCS,
	dt_IssuerAndSerialNumberPKCS,
	dt_ContentInfoPKCS,
	dt_SignerInfoPKCS,
	dt_SignerInfosPKCS,
	dt_RecipientInfoPKCS,
	dt_RecipientInfosPKCS,
	dt_EncryptedContentInfoPKCS,
	dt_SignedDataPKCS,
	dt_EnvelopedDataPKCS,
	dt_SignedAndEnvelopedDataPKCS,
	dt_DigestedDataPKCS,
	dt_EncryptedDataPKCS,
	dt_CertificationRequestInfoPKCS,
	dt_CertificationRequestPKCS,
	};

static ptpe *ptabl[] = {
	pt_RSAPrivateKeyPKCS,
	pt_ExtendedCertificateOrCertificatePKCS,
	pt_ExtendedCertificatesAndCertificatesPKCS,
	pt_ExtendedCertificateInfoPKCS,
	pt_ExtendedCertificatePKCS,
	pt_IssuerAndSerialNumberPKCS,
	pt_ContentInfoPKCS,
	pt_SignerInfoPKCS,
	pt_SignerInfosPKCS,
	pt_RecipientInfoPKCS,
	pt_RecipientInfosPKCS,
	pt_EncryptedContentInfoPKCS,
	pt_SignedDataPKCS,
	pt_EnvelopedDataPKCS,
	pt_SignedAndEnvelopedDataPKCS,
	pt_DigestedDataPKCS,
	pt_EncryptedDataPKCS,
	pt_CertificationRequestInfoPKCS,
	pt_CertificationRequestPKCS,
	};


/* Pointer table 68 entries */
caddr_t _ZptrtabPKCS[] = {
    (caddr_t ) "RSAPrivateKey",
    (caddr_t ) "version",
    (caddr_t ) "modulus",
    (caddr_t ) &_ZSEC_mod,
    (caddr_t ) "publicExponent",
    (caddr_t ) "privateExponent",
    (caddr_t ) "prime1",
    (caddr_t ) "prime2",
    (caddr_t ) "exponent1",
    (caddr_t ) "exponent2",
    (caddr_t ) "coefficient",
    (caddr_t ) "ExtendedCertificateOrCertificate",
    (caddr_t ) "certificate",
    (caddr_t ) &_ZSECAF_mod,
    (caddr_t ) "extendedCertificate",
    (caddr_t ) "ExtendedCertificatesAndCertificates",
    (caddr_t ) "ExtendedCertificateInfo",
    (caddr_t ) "attributes",
    (caddr_t ) &_ZSECIF_mod,
    (caddr_t ) "ExtendedCertificate",
    (caddr_t ) "extendedCertificateInfo",
    (caddr_t ) "signatureAlgorithm",
    (caddr_t ) "signature",
    (caddr_t ) "IssuerAndSerialNumber",
    (caddr_t ) "issuer",
    (caddr_t ) "serialNumber",
    (caddr_t ) "ContentInfo",
    (caddr_t ) "contentType",
    (caddr_t ) "content",
    (caddr_t ) "data",
    (caddr_t ) "signedData",
    (caddr_t ) "envelopedData",
    (caddr_t ) "signedAndEnvelopedData",
    (caddr_t ) "digestedData",
    (caddr_t ) "encryptedData",
    (caddr_t ) "SignerInfo",
    (caddr_t ) "issuerAndSerialNumber",
    (caddr_t ) "digestAlgorithm",
    (caddr_t ) "authenticatedAttributes",
    (caddr_t ) "digestEncryptionAlgorithm",
    (caddr_t ) "encryptedDigest",
    (caddr_t ) "unauthenticatedAttributes",
    (caddr_t ) "SignerInfos",
    (caddr_t ) "RecipientInfo",
    (caddr_t ) "keyEncryptionAlgorithm",
    (caddr_t ) "encryptedKey",
    (caddr_t ) "RecipientInfos",
    (caddr_t ) "EncryptedContentInfo",
    (caddr_t ) "contentEncryptionAlgorithm",
    (caddr_t ) "encryptedContent",
    (caddr_t ) "SignedData",
    (caddr_t ) "digestAlgorithms",
    (caddr_t ) "contentInfo",
    (caddr_t ) "certificates",
    (caddr_t ) "crls",
    (caddr_t ) "signerInfos",
    (caddr_t ) "EnvelopedData",
    (caddr_t ) "recipientInfos",
    (caddr_t ) "encryptedContentInfo",
    (caddr_t ) "SignedAndEnvelopedData",
    (caddr_t ) "DigestedData",
    (caddr_t ) "digest",
    (caddr_t ) "EncryptedData",
    (caddr_t ) "CertificationRequestInfo",
    (caddr_t ) "subject",
    (caddr_t ) "subjectPublicKeyInfo",
    (caddr_t ) "CertificationRequest",
    (caddr_t ) "certificationRequestInfo",
};

modtyp _ZPKCS_mod = {
	"PKCS",
	19,
	etabl,
	dtabl,
	ptabl,
	efn_PKCS,
	dfn_PKCS,
	0,
	_ZptrtabPKCS,
	};


#if	defined(lint) || defined(PEPSY_LINKABLE_FUNCS)

#undef parse_PKCS_RSAPrivateKey
int	parse_PKCS_RSAPrivateKey(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
RSAPrivateKey  **parm;
{
  return (dec_f(_ZRSAPrivateKeyPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_RSAPrivateKey
void free_PKCS_RSAPrivateKey(val)
RSAPrivateKey  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZRSAPrivateKeyPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_ExtendedCertificateOrCertificate
int	parse_PKCS_ExtendedCertificateOrCertificate(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
ExtendedCertificateOrCertificate  **parm;
{
  return (dec_f(_ZExtendedCertificateOrCertificatePKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_ExtendedCertificateOrCertificate
void free_PKCS_ExtendedCertificateOrCertificate(val)
ExtendedCertificateOrCertificate  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZExtendedCertificateOrCertificatePKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_ExtendedCertificatesAndCertificates
int	parse_PKCS_ExtendedCertificatesAndCertificates(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
ExtendedCertificatesAndCertificates  **parm;
{
  return (dec_f(_ZExtendedCertificatesAndCertificatesPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_ExtendedCertificatesAndCertificates
void free_PKCS_ExtendedCertificatesAndCertificates(val)
ExtendedCertificatesAndCertificates  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZExtendedCertificatesAndCertificatesPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_ExtendedCertificateInfo
int	parse_PKCS_ExtendedCertificateInfo(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
ExtendedCertificateInfo  **parm;
{
  return (dec_f(_ZExtendedCertificateInfoPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_ExtendedCertificateInfo
void free_PKCS_ExtendedCertificateInfo(val)
ExtendedCertificateInfo  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZExtendedCertificateInfoPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_ExtendedCertificate
int	parse_PKCS_ExtendedCertificate(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
ExtendedCertificate  **parm;
{
  return (dec_f(_ZExtendedCertificatePKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_ExtendedCertificate
void free_PKCS_ExtendedCertificate(val)
ExtendedCertificate  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZExtendedCertificatePKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_IssuerAndSerialNumber
int	parse_PKCS_IssuerAndSerialNumber(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
IssuerAndSerialNumber  **parm;
{
  return (dec_f(_ZIssuerAndSerialNumberPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_IssuerAndSerialNumber
void free_PKCS_IssuerAndSerialNumber(val)
IssuerAndSerialNumber  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZIssuerAndSerialNumberPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_ContentInfo
int	parse_PKCS_ContentInfo(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
ContentInfo  **parm;
{
  return (dec_f(_ZContentInfoPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_ContentInfo
void free_PKCS_ContentInfo(val)
ContentInfo  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZContentInfoPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_SignerInfo
int	parse_PKCS_SignerInfo(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
SignerInfo  **parm;
{
  return (dec_f(_ZSignerInfoPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_SignerInfo
void free_PKCS_SignerInfo(val)
SignerInfo  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZSignerInfoPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_SignerInfos
int	parse_PKCS_SignerInfos(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
SignerInfos  **parm;
{
  return (dec_f(_ZSignerInfosPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_SignerInfos
void free_PKCS_SignerInfos(val)
SignerInfos  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZSignerInfosPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_RecipientInfo
int	parse_PKCS_RecipientInfo(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
RecipientInfo  **parm;
{
  return (dec_f(_ZRecipientInfoPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_RecipientInfo
void free_PKCS_RecipientInfo(val)
RecipientInfo  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZRecipientInfoPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_RecipientInfos
int	parse_PKCS_RecipientInfos(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
RecipientInfos  **parm;
{
  return (dec_f(_ZRecipientInfosPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_RecipientInfos
void free_PKCS_RecipientInfos(val)
RecipientInfos  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZRecipientInfosPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_EncryptedContentInfo
int	parse_PKCS_EncryptedContentInfo(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
EncryptedContentInfo  **parm;
{
  return (dec_f(_ZEncryptedContentInfoPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_EncryptedContentInfo
void free_PKCS_EncryptedContentInfo(val)
EncryptedContentInfo  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZEncryptedContentInfoPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_SignedData
int	parse_PKCS_SignedData(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
SignedData  **parm;
{
  return (dec_f(_ZSignedDataPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_SignedData
void free_PKCS_SignedData(val)
SignedData  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZSignedDataPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_EnvelopedData
int	parse_PKCS_EnvelopedData(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
EnvelopedData  **parm;
{
  return (dec_f(_ZEnvelopedDataPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_EnvelopedData
void free_PKCS_EnvelopedData(val)
EnvelopedData  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZEnvelopedDataPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_SignedAndEnvelopedData
int	parse_PKCS_SignedAndEnvelopedData(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
SignedAndEnvelopedData  **parm;
{
  return (dec_f(_ZSignedAndEnvelopedDataPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_SignedAndEnvelopedData
void free_PKCS_SignedAndEnvelopedData(val)
SignedAndEnvelopedData  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZSignedAndEnvelopedDataPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_DigestedData
int	parse_PKCS_DigestedData(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
DigestedData  **parm;
{
  return (dec_f(_ZDigestedDataPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_DigestedData
void free_PKCS_DigestedData(val)
DigestedData  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZDigestedDataPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_EncryptedData
int	parse_PKCS_EncryptedData(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
EncryptedData  **parm;
{
  return (dec_f(_ZEncryptedDataPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_EncryptedData
void free_PKCS_EncryptedData(val)
EncryptedData  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZEncryptedDataPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_CertificationRequestInfo
int	parse_PKCS_CertificationRequestInfo(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
CertificationRequestInfo  **parm;
{
  return (dec_f(_ZCertificationRequestInfoPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_CertificationRequestInfo
void free_PKCS_CertificationRequestInfo(val)
CertificationRequestInfo  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZCertificationRequestInfoPKCS], &_ZPKCS_mod, 1);
}

#undef parse_PKCS_CertificationRequest
int	parse_PKCS_CertificationRequest(pe, top, len, buffer, parm)
PE	pe;
int	top,
       *len;
char  **buffer;
CertificationRequest  **parm;
{
  return (dec_f(_ZCertificationRequestPKCS, &_ZPKCS_mod, pe, top, len, buffer,
		(char **) parm));
}

#undef free_PKCS_CertificationRequest
void free_PKCS_CertificationRequest(val)
CertificationRequest  *val;
{
(void) fre_obj((char *) val, _ZPKCS_mod.md_dtab[_ZCertificationRequestPKCS], &_ZPKCS_mod, 1);
}

#endif	/* lint||PEPSY_LINKABLE_FUNCS */
