
# $Id: util.make,v 1.5 1995/03/08 07:32:17 surkau Exp surkau $

# $Log: util.make,v $
 
#
#  
#
#
#    Copyright (C) 1990-1994, GMD Darmstadt.
#
#                         NOTICE
#
#    Acquisition, use, and distribution of this module 
#    and related materials are subject to restrictions 
#    mentioned in each volume of the documentation.
#

MODULE = util

.c.o:
	$(CC) $*.c -c $(CFLAGS) $(DFLAGS) $(IFLAGS)

PGM     = encrypt sign verify hsh pem psemaint algs show sc_eject encode decode \
          getpkroot getfcpath instfcpath instpkroot instcert pkadd pkdel \
          psecreate genkey getkey cacreate certify revoke chpin gen_pse \
          showdir pklist mailpem scpsemaint \
          secude create_TestTree test_TestTree delete_TestTree inst_pse inst_ca g te tec \
	  secudeversion getalias install_sct


all: $(PGM)

clean:
	@touch % bak.bak o.o; rm -f *.o *.bak *% core $(PGM)

cleanpgm:
	@rm -f $(PGM)

psemaint: psemaint.o
	$(CC) psemaint.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

scpsemaint: scpsemaint.o
	$(CC) scpsemaint.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

sc_eject: sc_eject.o
	$(CC) sc_eject.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

install_sct: install_sct.o
	$(CC) install_sct.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

sign: sign.o
	$(CC) sign.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

verify: verify.o
	$(CC) verify.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

show: show.o
	$(CC) show.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

hsh: hsh.o
	$(CC) hsh.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

algs: algs.o
	$(CC) algs.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

encrypt: encrypt.o
	$(CC) encrypt.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .; rm -f decrypt; ln encrypt decrypt

encode: encode.o
	$(CC) encode.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

decode: decode.o
	$(CC) decode.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

pem:    pem.o
	$(CC) pem.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

gen_pse: gen_pse.o
	$(CC) gen_pse.o -o $@ $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

instcert: instcert.o
	$(CC) instcert.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

instpkroot: instpkroot.o
	$(CC) instpkroot.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

instfcpath: instfcpath.o
	$(CC) instfcpath.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

getpkroot: getpkroot.o
	$(CC) getpkroot.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

getfcpath: getfcpath.o
	$(CC) getfcpath.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

getkey: getkey.o
	$(CC) getkey.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

psecreate: psecreate.o
	$(CC) psecreate.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

genkey: genkey.o
	$(CC) genkey.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

certify: certify.o
	$(CC) certify.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

cacreate: cacreate.o
	$(CC) cacreate.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

showdir: showdir.o
	$(CC) showdir.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

revoke: revoke.o
	$(CC) revoke.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

pklist: pklist.o
	$(CC) pklist.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

pkadd:  pkadd.o
	$(CC) pkadd.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

pkdel: pkdel.o
	$(CC) pkdel.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

secudeversion: secudeversion.o 
	$(CC) secudeversion.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

create_TestTree: create_TestTree.sh
	cp create_TestTree.sh create_TestTree
	chmod a+x create_TestTree
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

test_TestTree: test_TestTree.sh
	cp test_TestTree.sh test_TestTree
	chmod a+x test_TestTree
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

delete_TestTree: delete_TestTree.sh
	cp delete_TestTree.sh delete_TestTree
	chmod a+x delete_TestTree
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

chpin: chpin.sh
	cp chpin.sh chpin
	chmod a+x chpin
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

mailpem: mailpem.sh
	cp mailpem.sh mailpem
	chmod a+x mailpem
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

secude: secude.sh
	cp secude.sh secude
	chmod a+x secude
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

g: g.sh
	cp g.sh g
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

te: te.sh
	cp te.sh te
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

tec: tec.sh
	cp tec.sh tec
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

inst_pse: inst_pse.sh
	cp inst_pse.sh inst_pse
	chmod a+x inst_pse
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

inst_ca: inst_ca.sh
	cp inst_ca.sh inst_ca
	chmod a+x inst_ca
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

getalias:  getalias.o
	$(CC) getalias.o -o $@  $(LFLAGS) $(LIB) $(UCBLIB)
	@cd ../../bin; rm -f $@; ln ../src/util/$@ .

