
# $Id: util.pure.make,v 1.4 1994/11/02 10:44:39 surkau Exp $

# $Log: util.pure.make,v $
 
#
#  
#
#
#    Copyright (C) 1990-1994, GMD Darmstadt.
#
#                         NOTICE
#
#    Acquisition, use, and distribution of this module 
#    and related materials are subject to restrictions 
#    mentioned in each volume of the documentation.
#

.c.o:;		$(PURIFY) $(PURIFYFLAGS) $(CC) $*.c -c $(CFLAGS) $(IFLAGS) $(CPPFLAGS)



PGM     = encrypt sign verify hsh pem psemaint algs show sc_eject encode decode \
          getpkroot getfcpath instfcpath instpkroot instcert pkadd pkdel \
          psecreate genkey getkey cacreate certify revoke chpin gen_pse \
          showdir pklist mailpem \
          secude create_TestTree delete_TestTree inst_pse inst_ca g te tec \
	  secudeversion


DTESTKEYS   = -DTESTKEYS_PSE=\"$(TOP)/lib/.testkeys\"
DFLAGS      = $(DX500) $(DSTRONG) $(DCOSINE) $(DAFDB) $(DTEST) $(SPECIALS) $(DISODE80) $(DICR1)


all: make

cleanpgm:
	rm -f $(PGM)

algs.o: algs.c
	$(PURIFY) $(PURIFYFLAGS) $(CC) algs.c -c $(CFLAGS) $(IFLAGS) $(DTIME) $(DTESTKEYS)

sign.o: sign.c
	$(PURIFY) $(PURIFYFLAGS) $(CC) sign.c -c $(CFLAGS) $(IFLAGS) $(DTIME)

verify.o: verify.c
	$(PURIFY) $(PURIFYFLAGS) $(CC) verify.c -c $(CFLAGS) $(IFLAGS) $(DTIME)

encrypt.o: encrypt.c
	$(PURIFY) $(PURIFYFLAGS) $(CC) encrypt.c -c $(CFLAGS) $(IFLAGS) $(DTIME)

cacreate.o:	cacreate.c
	$(PURIFY) $(PURIFYFLAGS) $(CC) cacreate.c -c $(CFLAGS) $(IFLAGS) $(DBMVERS) 

gen_pse.o:	gen_pse.c
	$(PURIFY) $(PURIFYFLAGS) $(CC) gen_pse.c -c $(CFLAGS) $(IFLAGS) $(DBMVERS) $(DNO_SETRUID)

make: $(PGM)
	cp $? $(BINDIR)
	rm -f $(BINDIR)/decrypt
	ln -s encrypt $(BINDIR)/decrypt
	touch make
	chmod a+x $(BINDIR)/create_TestTree $(BINDIR)/delete_TestTree $(BINDIR)/g $(BINDIR)/te
	chmod a+x $(BINDIR)/inst_ca $(BINDIR)/inst_pse $(BINDIR)/chpin $(BINDIR)/tec $(BINDIR)/mailpem

psemaint: psemaint.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) psemaint.o -o $@ $(LFLAGS) $(LIB)

sc_eject: sc_eject.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) sc_eject.o -o $@ $(LFLAGS) $(LIB)

sign: sign.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) sign.o -o $@ $(LFLAGS) $(LIB)

verify: verify.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) verify.o -o $@ $(LFLAGS) $(LIB)

show: show.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) show.o -o $@ $(LFLAGS) $(LIB)

hsh: hsh.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) hsh.o -o $@ $(LFLAGS) $(LIB)

algs: algs.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) algs.o -o $@ $(LFLAGS) $(LIB)

encrypt: encrypt.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) encrypt.o -o $@  $(LFLAGS) $(LIB)

encode: encode.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) encode.o -o $@  $(LFLAGS) $(LIB)

decode: decode.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) decode.o -o $@  $(LFLAGS) $(LIB)

munzert: munzert.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) munzert.o -o $@  $(LFLAGS) $(LIB)

pem:    pem.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) pem.o -o $@  $(LFLAGS) $(LIB)

gen_pse: gen_pse.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) gen_pse.o -o $@ $(LFLAGS) $(LIB)

instcert: instcert.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) instcert.o -o $@  $(LFLAGS) $(LIB)

instpkroot: instpkroot.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) instpkroot.o -o $@  $(LFLAGS) $(LIB)

instfcpath: instfcpath.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) instfcpath.o -o $@  $(LFLAGS) $(LIB)

getpkroot: getpkroot.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) getpkroot.o -o $@  $(LFLAGS) $(LIB)

getfcpath: getfcpath.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) getfcpath.o -o $@  $(LFLAGS) $(LIB)

getkey: getkey.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) getkey.o -o $@  $(LFLAGS) $(LIB)

psecreate: psecreate.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) psecreate.o -o $@  $(LFLAGS) $(LIB)

genkey: genkey.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) genkey.o -o $@  $(LFLAGS) $(LIB)

certify: certify.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) certify.o -o $@  $(LFLAGS) $(LIB)

cacreate: cacreate.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) cacreate.o -o $@  $(LFLAGS) $(LIB)

showdir: showdir.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) showdir.o -o $@  $(LFLAGS) $(LIB)

revoke: revoke.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) revoke.o -o $@  $(LFLAGS) $(LIB)

pklist: pklist.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) pklist.o -o $@  $(LFLAGS) $(LIB)

pkadd:  pkadd.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) pkadd.o -o $@  $(LFLAGS) $(LIB)

pkdel: pkdel.o
	$(PURIFY) $(PURIFYFLAGS) $(CC) pkdel.o -o $@  $(LFLAGS) $(LIB)

secudeversion: secudeversion.o 
	$(PURIFY) $(PURIFYFLAGS) $(CC) secudeversion.o -o $@  $(LFLAGS) $(LIB)

create_TestTree: create_TestTree.sh
	cp create_TestTree.sh create_TestTree

delete_TestTree: delete_TestTree.sh
	cp delete_TestTree.sh delete_TestTree

chpin: chpin.sh
	cp chpin.sh chpin

mailpem: mailpem.sh
	cp mailpem.sh mailpem

secude: secude.sh
	cp secude.sh secude

g: g.sh
	cp g.sh g

te: te.sh
	cp te.sh te

tec: tec.sh
	cp tec.sh tec

inst_pse: inst_pse.sh
	cp inst_pse.sh inst_pse

inst_ca: inst_ca.sh
	cp inst_ca.sh inst_ca

