/* ./src/util/xmsectool/clipboard.h */

/*
 * $Id: clipboard.h,v 1.9 1995/03/06 13:46:06 nuessler Exp $
 *
 * $Log: clipboard.h,v $
 * #endif
 *                          inserted
 *
 * Revision 1.7  1994/12/20  18:04:07  koletzki
 * improved & bugfixed:
 *
 * 	configuration
 * 	properties
 * 	clipboard
 *
 * Revision 1.6  1994/12/09  17:02:27  koletzki
 * clipboard copy/retrieve/swap
 * object copy/cut
 *
 * Revision 1.5  1994/11/02  10:44:39  surkau
 * Header replaced by Id
 *
 * Revision 1.4  1994/11/02  09:39:08  surkau
 * SecuDE-4.4.a0
 *
 *
 */
 
/********************************************************************
 * Copyright (C) 1990-1994, GMD Darmstadt. All rights reserved.     *
 *                                                                  *
 *                                                                  *
 *                         NOTICE                                   *
 *                                                                  *
 *    Acquisition, use, and distribution of this module             *
 *    and related materials are subject to restrictions             *
 *    mentioned in each volume of the documentation.                *
 *                                                                  *
 ********************************************************************/

#ifndef CLIPBOARD_H
#define CLIPBOARD_H


/*
 *	Clipboard types
 */
typedef enum {
	CB_EMPTY = -2,
	CB_ERROR = -1,
	CB_PSE = 0,
	CB_PK,
	CB_EK,
	CB_PCA,
	CB_X500,
	CB_AFDB,
	CB_UNKNOWN
} ClipboardSource;

extern char		*ClipboardSource_name[];

extern int		clipboardUndoCount;



/*
 *	Macros
 */
#define XMST_CLEAR_CLIPBOARD_FORMAT	"CLEAR_OctetString"
#define XMST_CRYPTED_CLIPBOARD_FORMAT	"ENCRYPTED_BitString"
#define XMST_CLIPBOARD_FORMAT_LENGTH	32
#define XMST_CLIPBOARD_LABEL		XMST_VERSION
#define XMST_MAX_UNDOS			2

/*** end clipboards.h ***/
#endif


 



