/* ./src/util/xmsectool/init.c */

static char *rcsid = "$Id: init.c,v 1.22 1995/03/14 17:15:20 koletzki Exp $";

/*
 * $Id: init.c,v 1.22 1995/03/14 17:15:20 koletzki Exp $
 *
 * $Log: init.c,v $
 * 	configuration
 * 	properties
 * 	clipboard
 *
 * Revision 1.15  1994/12/15  17:28:33  nuessler
 * Included:
 * - array of struct of xmst-shells
 * - insert all new shell-widgets in this table
 *
 * Revision 1.14  1994/12/15  14:41:58  koletzki
 * *** empty log message ***
 *
 * Revision 1.13  1994/12/09  16:56:53  nuessler
 * There is a better and nicer busy - and think
 * Cursor function called setCursor!
 *
 * Revision 1.12  1994/12/09  15:23:42  koletzki
 * *** empty log message ***
 *
 * Revision 1.11  1994/12/02  14:35:45  koletzki
 * vendor pixmap
 * clipboard copy/retrieve
 *
 * Revision 1.10  1994/11/24  18:15:56  koletzki
 * *** empty log message ***
 *
 * Revision 1.9  1994/11/21  12:02:55  nuessler
 * *** empty log message ***
 *
 * Revision 1.7  1994/11/11  11:09:20  koletzki
 * some changes for proper installation in /usr/local/secude
 *
 * Revision 1.6  1994/11/04  15:44:07  koletzki
 * Refresh-Button:
 * 	re-open current PSE, re-read objects
 *
 * Revision 1.5  1994/11/02  10:44:39  surkau
 * Header replaced by Id
 *
 * Revision 1.4  1994/11/02  09:39:08  surkau
 * SecuDE-4.4.a0
 *
 *
 */
 
/********************************************************************
 * Copyright (C) 1990-1994, GMD Darmstadt. All rights reserved.     *
 *                                                                  *
 *                                                                  *
 *                         NOTICE                                   *
 *                                                                  *
 *    Acquisition, use, and distribution of this module             *
 *    and related materials are subject to restrictions             *
 *    mentioned in each volume of the documentation.                *
 *                                                                  *
 ********************************************************************/



/*
 ************************
 *	includes	*
 ************************
 */

#include "xmst.h"



/*
 *************************************
 *	Declaration & Definition Stuff
 *************************************
 */


XrmDatabase	config_database;

/*
 *	Self defined X Resource values
 */
ApplResType	applResources; 
char		*external_editor;
char		*print_command;
Pixel		focus_color;
Pixel		active_list_color;

/* Clipboard types */
char		*ClipboardSource_name[] = {
			"PSE",
			"PKList",
			"EKList",
			"PCAList",
			"X.500",
			"AF-DB",
			"Unknown"
		};

int		clipboardUndoCount = 0;

/*
 *	UIL
 */
MrmHierarchy	applicationHierarchy;
char		*applicationUidVector[] = {"xmst.uid"};
MrmType		opaqueClass;
int		*keysizeScaleMinimum;
int		*keysizeScaleMaximum;

/*
 *	Xmst Shells
 */

XmstShells xmstshells[]={
/* reserved for widget       name	       cursor resizab. managed geometry  */
	{ NULL, 	"", /* = stMainShell */	TRUE,	TRUE,	TRUE,	NULL  },	
	{ NULL, 	"*debug_dialog",	TRUE,	TRUE,	FALSE,	NULL  },
	{ NULL, 	"*guide_dialog", 	TRUE,	TRUE,	FALSE,	NULL  },
	{ NULL, 	"*viewer_dialog",	TRUE,	TRUE,	FALSE,	NULL  },
	{ NULL, 	"*d5bwr_dialog",	TRUE,	TRUE,	FALSE,	NULL  },
	{ NULL, 	"*clipboard_dialog",	TRUE,	TRUE,	FALSE,	NULL  },
	{ NULL, 	"*alias_dialog",	TRUE,	TRUE,	FALSE,	NULL  },
	{ NULL, 	"*config_dialog",	FALSE,	FALSE,	FALSE,	NULL  },
	{ NULL, 	"*file_dialog", 	TRUE,	FALSE,	FALSE,	NULL  },
	{ NULL, 	"*crypt_dialog",	TRUE,	FALSE,	FALSE,	NULL  },
	{ NULL, 	"*secude_dialog",	TRUE,	FALSE,	FALSE,	NULL  },
	{ NULL, 	NULL }
};

/* dialog widgets */
Widget		fileDialog = NULL;
Widget		cryptDialog = NULL;

/*
 *	Display/Screen/Shells/Widgets
 */
XtAppContext	applicationContext;
Display		*display;
Screen		*screen;
Widget		applicationShell;



/*
 *	Args, Flags, Names
 */
int 		xmst_argc;
char 		**xmst_argv;
char 		*argPSEName = CNULL;
char 		*argCAName = CNULL;
Boolean		debugmode_on;				/* Flag for Debug Toggle Button state */
Boolean		alias_save_required;			/* Alias Editor has made changes in Alias List */
Boolean 	verbose = FALSE;
Boolean 	sectool_verbose = FALSE;
int		error_verbose = 0;
Boolean		Debug = FALSE;				/* Flag for Debugger initial state */
Boolean		auto_save_configuration = FALSE;	/* save configuration in .xinitrc on exit */
Boolean		auto_detect_sct = FALSE;
Boolean		use_external_editor = FALSE;
Boolean		beep_on_error = FALSE;
Boolean		cryptoClipboard = TRUE;
char		*unix_home;
char		*editor_tempfile;
char		*guide_file;
char		*config_rcfile;
char		*d5bwr_tempfile;
char		dialog_message[1111];
char		*alias_to_add;
char		*alias_message[] = {	"Alias",
					"Internet Mail Address",
					"X.400 Address",
					"Local Name"			};
int		pin_failure_count;
char		dialog_pin[XMST_PIN_LENGTH + 1];
Boolean		dialog_finished;
Boolean		dialog_ok;



/*
 *******************************
 *	SecuDE Declaration Stuff
 *******************************
 */


Command     		cmd;
Boolean 		replace;
char    		inp[256];
char    		* cmdname, * helpname, * filename, * pin, * newpin, * algname, * objtype, * attrname;
CertificateType 	certtype;
KeyRef  		keyref;
Key     		*key, *publickey, *secretkey;
Boolean 		interactive = TRUE;
char 			*pname, *ppin;
int 			pkeyref;
char			*newstring;
int            		fd1, fd2, fdin;
int             	i, anz, n, k, algtype, found;
time_t          	atime, etime;
char	        	x500 = TRUE;
Boolean         	update, create, replace_afdb_cert;
char            	*enc_file, *plain_file, *tbs_file, *sign_file, *hash_file;
char            	*buf1, *buf2, *ii, *xx;
char            	*par, *dd, *ptr, *cc, *afname, *newname, *objname, *number;
char	        	*pgm_name;
char 	        	*revlistpempath;
char            	*pse_name = CNULL, *pse_path = CNULL, *ca_dir = CNULL, *home;
char            	*last_pse_name = CNULL, *last_ca_dir = CNULL;
RC              	rcode_dir, rcode_afdb, rcode;
OctetString     	octetstring, *ostr, *objectvalue, *tmp_ostr;
ObjId    		*object_oid, oid;
AlgId           	*algid;
BitString       	bitstring, *bstr;
HashInput       	hashinput;
KeyInfo         	tmpkey, *keyinfo, *signpk, *encpk, session_key;
FCPath          	*fcpath;
Certificate          	*fcpath_cert;
PKList          	*pklist;
PKRoot          	*pkroot;
Certificate     	*certificate;
Certificates    	*certs;
ToBeSigned 		*tbs;
SET_OF_Certificate 	*certset, *soc, *tmp_soc;
CertificatePair 	*cpair;
SET_OF_CertificatePair  *cpairset;
SEQUENCE_OF_CRLEntry 	*revcertpemseq;
Crl			* crlpse;
CrlSet      		* crlset;
Name            	*name, *alias, * issuer, * subject;
DName			* dname, * issuer_dn, * subject_dn, * own_dname, * signsubject, * encsubject;
EncryptedKey    	encryptedkey;
rsa_parm_type   	*rsaparm;
KeyType         	ktype;
AlgEnc          	algenc;
PSESel  		std_pse;
PSESel          	*pse_sel;
PSEToc          	*psetoc, *sctoc;
struct PSE_Objects 	*pseobj;
OctetString		*serial;
SET_OF_IssuedCertificate *isscertset;
SET_OF_Name		*nameset;
UTCTime 		*lastUpdate, *nextUpdate;	
AlgList         	*a;
Boolean         	onekeypaironly = FALSE;
AliasFile		aliasfile;
AliasList               *aliaslist;
PSELocation 		pse_location;

#ifdef X500
int 		 	dsap_index;
char			*callflag;
DName 			*directory_user_dname = NULLDNAME;
int     		count;			
char 			**vecptr;   		
int     		af_dir_authlevel;		
char     		*env_af_dir_authlevel;		
#endif

#ifdef SCA
int			SCapp_available;		
#endif

char 			*passwd; 	/* store user-typed passwd here. */
Boolean			start_with_configuration = FALSE;

Key     		*clipboard_sessionkey;





